<html>
<head>
    <meta charset="utf-8">
    <title>Datenbank Datensatz einfügen</title>
</head>
<body>
<?php // ********** ab hier PHP **********
// ************************************************************************************************
// Datensatze einer Tabelle in die Datenbank einfügen
// $_POST[] Eingabewerte:
// database: Datenbank, aus der die Tabelle kommt.
// table:    Tabelle, in die ein Datensatz eingefügt wird
// in-???:   Attribute des Datensatzes
// ************************************************************************************************
// Kopfzeile einbinden
include "khsw.php";
// ************************************************************************************************
// POST-Variablen auslesen
// ************************************************************************************************
echo "Liste aller POST-Variablen<br>";
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    foreach($_POST as $key => $value) {
        $value = trim($value);
        $value = stripslashes($value);
        $value = htmlspecialchars($value);
        $$key=$value;
        echo '$_POST["'.$key.'"]="'.$value.'"<br>';
    }
}
// ************************************************************************************************
// Verbindung zum Server aufbauen, Datenbank, Tabelle auswählen
// persönliche Konfigurationsdaten einbinden
include "config.inc.php";
// Verbindung zum Datenbankserver definieren
$conn = new mysqli($servername, $username, $password);
// Verbindung prüfen
if ($conn->connect_error) { // Abbruch bei Fehler
  die("<p>Verbindung zum Server ".$servername." misslungen: " . $conn->connect_error."<p>\n");
}
$conn->set_charset('utf8'); // Zeichensatz utf-8 für die Verbindung zum Server einstellen
// Datenbanknamen und Tabelle prüfen
if (empty($database) || empty($table)) die("<p>Datenbank oder Tabelle nicht angegeben.</p>");
// Verbindung zur Datenbank aufbauen
$sql="USE $database";
if ($conn->query($sql) === TRUE) {
    echo "<p>Verbindung zur Datenbank $database erfolgreich.</p>\n";
} else {
    die("<p>Fehler bei der Verbindung zur Datenbank $database: " . $conn->error."</p>\n");
}
// beim ersten Attribut brauchen wir kein Komma
$columns=""; $values=""; $komma="";
// Aufgabe 2.4.3: $columns und $values füllen, damit der INSERT-Befehl stimmt.

// SQL-Befehl für das INSERT zusammenbauen
$sql="INSERT INTO $table ($columns) VALUES ($values)";
echo "<p>Tabelle $table, SQL-Befehl:<br>$sql</p>";
// den UPDATE-Befehl an den Server schicken
$result = $conn->query($sql);
if ($result===TRUE) {
    echo "<p>Einfügen erfolgreich</p>";
} else {
    echo "<p>Fehler: Einfügen NICHT erfolgreich: ".$conn->error."</p>";
}
// Schaltfläche zum Anzeigen der Tabelle bauen
echo "<form action='table.php' method='post'>\n";
echo "<input type='hidden' name='database' value='$database'>\n";
echo "<input type='hidden' name='table' value='$table'>\n";
echo "<input type='submit' value='Tabelle anzeigen'>\n";
echo "</form>\n";

// ************************************************************************************************
// Verbindung zum Datenbankserver schließen
$conn->close(); // ********** ab hier HTML **********
?> 
</body>
</html>