<html>
<head>
    <meta charset="utf-8">
    <title>Datenbank: neuer Datensatz</title>
</head>
<body>
<?php // ********** ab hier PHP **********
// Kopfzeile einbinden
include "khsw.php";
// ************************************************************************************************
// POST-Variablen auslesen
// ************************************************************************************************
echo "Liste aller POST-Variablen<br>";
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    foreach($_POST as $key => $value) {
        $value = trim($value);
        $value = stripslashes($value);
        $value = htmlspecialchars($value);
        $$key=$value;
        echo '$_POST["'.$key.'"]="'.$value.'"<br>';
    }
}
// ************************************************************************************************
// Verbindung zum Server aufbauen, Datenbank, Tabelle auswählen
// ************************************************************************************************
// persönliche Konfigurationsdaten einbinden
include "config.inc.php";
// Datenbanknamen und Tabelle festlegen, falls nicht per POST übergeben
if (empty($database)) $database=$username."_eurodata";
if (empty($table)) $table="mitarbeiter";
// Verbindung zum Datenbankserver definieren
$conn = new mysqli($servername, $username, $password);
// Verbindung zum Server prüfen
if ($conn->connect_error) { // Abbruch bei Fehler
  die("<p>Verbindung zum Server ".$servername." misslungen: " . $conn->connect_error."<p>\n");
}
// Zeichensatz utf-8 für die Verbindung zum Server einstellen
$conn->set_charset('utf8');
// Verbindung zur Datenbank aufbauen
$sql="USE $database";
if ($conn->query($sql) === TRUE) {
    echo "<p>Verbindung zur Datenbank $database erfolgreich.</p>\n";
} else {
    die("<p>Fehler bei der Verbindung zur Datenbank $database: " . $conn->error."</p>\n");
}
// ************************************************************************************************
// $sql = "SELECT * FROM information_schema.COLUMNS WHERE TABLE_SCHEMA='aaa_bibliothek' AND TABLE_NAME='$table' ORDER BY ORDINAL_POSITION;";
// Primärschlüssel, Datentypen und Extras bestimmen, um jedes Eingabefeld möglichst treffend behandeln zu können
//$sql = "SHOW COLUMNS FROM `$table` WHERE `Key`='PRI'";
// Airbag für die Vorbereitung: falls die Primärschlüssel nicht oder falsch gesetzt wurden
$sql = "SHOW COLUMNS FROM `aaa_bibliothek`.`$table`";
echo "<p>Tabelle $table, SQL-Befehl zum Herausfinden der Spalten: $sql</p>";
$result = $conn->query($sql);
// ************************************************************************************************
// Eingabemaske anzeigen
// ************************************************************************************************
if ($result->num_rows > 0) {
    // Die Tabelle enthält Attribute: FORM und HTML-Tabelle vorbereiten
    // die form umschließt alles
    echo "<form action='new-insert.php' method='post'>\n";
    // In der Tabelle werden alle Eingabefelder systematisch dargestellt
    echo "<table style='background-color: #CCCCCC; border: 1px solid black;'>";
    // Überschrift der Tabelle
    echo "<tr><th>Eigenschaft</th><th>Wert</th></tr>";
    // Datensatz in das assoziative Array $row[] einlesen
    while ($row = $result->fetch_assoc()) {
        // Nacheinander alle Spalten/Attribute des Datensatzes bearbeiten und Namen bzw. Inhalt darstellen
        $key=$row["Field"];
        $datatype=$row["Type"];
        $auto_increment=$row["Extra"]=="auto_increment";
        // Herausfinden, ob ein $key Fremdschlüssel ist
        $sql2="SELECT * FROM information_schema.KEY_COLUMN_USAGE WHERE TABLE_SCHEMA='aaa_bibliothek' AND TABLE_NAME='$table' AND COLUMN_NAME='$key' AND CONSTRAINT_NAME!='PRIMARY';";
        $result2 = $conn->query($sql2);
        if ($result2->num_rows > 0) { // Fremdschlüssel erkannt
            $row2 = $result2->fetch_assoc(); // Namen der Mastertabelle und des Primärschlüssels holen
            $foreignTable=$row2["REFERENCED_TABLE_NAME"];
            $foreignKey  =$row2["REFERENCED_COLUMN_NAME"];
            $displayKey  =$foreignKey;
        } else {
            $foreignTable="";
        }
        // Namen in Spalte 1 darstellen
	    echo "<tr><td>$key</td>";
        // Auf Fremdschlüssel und Datentypen reagieren für Eingabefelder
        if ($foreignTable!="") { // Fremdschlüssel als DropDown darstellen
            $sql2 = "SELECT $foreignKey, $displayKey FROM $foreignTable ORDER BY $displayKey;";
            $result2 = $conn->query($sql2);
            // Aufgabe 2.4.2
            // Der SQL-Befehl in die Masertabelle ist bereits abgesetzt. Sie müssen die Werte darstellen.
            echo "<td>[Hier soll ein Popup erscheinen]</td></tr>\n";
        }
        else if ($auto_increment) { // Primärschlüssel, der automatisch gesetzt wird
            echo "<td>[automatischer Wert]</td></tr>\n";
        }
        else if ($datatype=="datetime") { // Datum und Uhrzeit
            echo "<td><input type='datetime-local' name='in-$key'></td></tr>\n";
        }
        else if ($datatype=="date") { // Datum
            echo "<td><input type='date' name='in-$key'></td></tr>\n";
        }
        else { // Wenn keine Besonderheit vorliegt, ein einfaches Eingabefeld verwenden
            echo "<td><input type='text' name='in-$key'></td></tr>\n";
        }
    }
    echo "<tr><td>&nbsp;</td><td><input type='hidden' name='database' value='$database'>\n";
    echo "<input type='hidden' name='table' value='$table'>\n";
    echo "<input type='submit' value='Anlegen'>\n";
    echo "</td></tr></table>\n";
    echo "</form>\n";
}
else {
    echo "<p>Keine Informationen über die Tabelle verfügbar.</p>";
}
// ************************************************************************************************
// Verbindung zum Datenbankserver schließen
$conn->close(); // ********** ab hier HTML **********
?> 

<p><a href="javascript:history.back()">Zurück</a></p>
</body>
</html>