<html>
<head>
    <meta charset="utf-8">
    <title>Datenbank Datensatz ändern</title>
</head>
<body>
<?php // ********** ab hier PHP **********
// ************************************************************************************************
// Datensatze einer Tabelle in der Datenbank ändern
// $_POST[] Eingabewerte:
// database: Datenbank, aus der die Tabelle kommt.
// table:    Tabelle, aus der ein Datensatz geändert wird
// where:    Bedingung hinter WHERE, die den Datensatz eindeutig beschreibt
// in-???:   Attribute, die geändert werden sollen
// ************************************************************************************************
// Kopfzeile einbinden
include "khsw.php";
// ************************************************************************************************
// POST-Variablen auslesen
// ************************************************************************************************
echo "Liste aller POST-Variablen<br>";
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    foreach($_POST as $key => $value) {
        $value = trim($value);
        $value = stripslashes($value);
        $value = htmlspecialchars($value);
        $$key=$value;
        echo '$_POST["'.$key.'"]="'.$value.'"<br>';
    }
}
// ************************************************************************************************
// Verbindung zum Server aufbauen, Datenbank, Tabelle auswählen
// persönliche Konfigurationsdaten einbinden
include "config.inc.php";
// Datenbanknamen und Tabelle festlegen
if (empty($database)) $database=$username."_eurodata";
if (empty($table)) $table="mitarbeiter";
// Verbindung zum Datenbankserver definieren
$conn = new mysqli($servername, $username, $password);
// Verbindung prüfen
if ($conn->connect_error) { // Abbruch bei Fehler
  die("<p>Verbindung zum Server ".$servername." misslungen: " . $conn->connect_error."<p>\n");
}
$conn->set_charset('utf8'); // Zeichensatz utf-8 für die Verbindung zum Server einstellen
// Verbindung zur Datenbank aufbauen
$sql="USE $database";
if ($conn->query($sql) === TRUE) {
    echo "<p>Verbindung zur Datenbank $database erfolgreich.</p>\n";
} else {
    die("<p>Fehler bei der Verbindung zur Datenbank $database: " . $conn->error."</p>\n");
}
// SQL-Befehl für das UPDATE zusammenbauen
$sql="UPDATE $table SET ";
// beim ersten Attribut brauchen wir kein Komma
$komma="";
foreach($_POST as $key => $value) {
    if (substr($key,0,3)=="in-") {
        // den Namen des Attributes ohne das führende "in-" ermitteln
        $keyohnein=substr($key,3);
        // bei Bedarf ein Komma, den Namen des Attributes und dann den Wert eingeschlssen in Gänsefüßchen einbauen
        $sql .= $komma . "$keyohnein=\"" . $$key . "\"";
        // Ab jetzt brauchen wir ein Komma zum Trennen der einzelnen Attribute
        $komma=", ";
    }
}
// den zu ändernden Datensatz mit WHERE einbauen
$sql.=" WHERE $where;";
echo "<p>Tabelle $table, SQL-Befehl:<br>$sql</p>";
// den UPDATE-Befehl an den Server schicken
$result = $conn->query($sql);
if ($result===TRUE) {
    echo "<p>Änderung erfolgreich</p>";
} else {
    echo "<p>Fehler: Änderung NICHT erfolgreich</p>";
}
// Schaltfläche zum Anzeigen der Tabelle bauen
echo "<form action='db.php' method='post'>\n";
echo "<input type='hidden' name='database' value='$database'>\n";
echo "<input type='hidden' name='table' value='$table'>\n";
echo "<input type='submit' value='Tabelle anzeigen'>\n";
echo "</form>\n";

// ************************************************************************************************
// Verbindung zum Datenbankserver schließen
$conn->close(); // ********** ab hier HTML **********
?> 
</body>
</html> 