<html>
<head>
    <meta charset="utf-8">
    <title>Datenbank Tabellenübersicht</title>
</head>
<body>
<?php
// ************************************************************************************************
// Tabellenübersicht über eine Datenbank ausgeben
// $_POST[] Eingabewerte:
// database: Datenbank, deren Tabellen dargestellt werden. Standardwert: $username."_bibliothek"
// ************************************************************************************************
// Kopfzeile einbinden
include "khsw.php";
// ************************************************************************************************
// POST-Variablen auslesen
// ************************************************************************************************
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    foreach($_POST as $key => $value) {
        $value = trim($value);
        $value = stripslashes($value);
        $value = htmlspecialchars($value);
        $$key=$value;
    }
}
// ************************************************************************************************
// Verbindung zum Server aufbauen, Datenbank, Tabelle auswählen
// persönliche Konfigurationsdaten einbinden
if (!@include "config.inc.php") die("<p>Bitte kopieren Sie Ihre eigene config.inc.php hierher: ".__DIR__.".</p>\n");
// Datenbanknamen festlegen
if (empty($database)) $database=$username."_bibliothek";
// Verbindung zum Datenbankserver definieren
$conn = new mysqli($servername, $username, $password);
// Verbindung prüfen
if ($conn->connect_error) { // Abbruch bei Fehler
  die("<p>Verbindung zum Server ".$servername." misslungen: " . $conn->connect_error."<p>\n");
}
$conn->set_charset('utf8'); // Zeichensatz utf-8 für die Verbindung zum Server einstellen
echo "<p>Datenbank: $database</p>";
// ************************************************************************************************
// Tabellen in der Datenbank in einer HTML-Tabelle anzeigen. SQL-Befehl: SHOW TABLES FROM database
    $sql = "SHOW TABLES FROM `$database`;";
    $result = $conn->query($sql);
    if ($result->num_rows > 0) { // Es gibt SQL-Tabellen: HTML-Tabelle vorbereiten
        echo '<table style="background-color: #AAAAAA; border: 1px solid black;">';
        echo '<tr><th>Tabelle</th><th>Aktionen</th></tr>';
        // alle Zeilen einzeln ausgeben
        while ($row = $result->fetch_array(MYSQLI_NUM)) {
            // Namen der SQL-Tabellen ausgeben
            echo "<tr>";
	        $table=$row[0];
	        echo "<td style='border: 1px solid white;'>".$table."</td>";
	        // Aktionen der SQL-Tabellen ausgeben
	        echo "<td style='border: 1px solid white;'>
	        <form action='table.php' method='post'>
	        <input type='hidden' name='table' value='".$table."'>
	        <input type='hidden' name='database' value='".$database."'>
	        <input type='submit' value='Anzeigen'>
	        </form></td>";
	        echo "</tr>\n";
        }
        echo "</table>\n";
    } else {
    echo "<p>Die Datenbank $database ist leer</p>\n";
    }
// ************************************************************************************************
// Verbindung zum Datenbankserver schließen
$conn->close(); // ********** ab hier HTML **********
?> 

</body>
</html> 