<html>
<head>
    <meta charset="utf-8">
    <title>Datenbank Datensätze einer Tabelle zeigen</title>
</head>
<body>
<?php // ********** ab hier PHP **********
// ************************************************************************************************
// Datensätze einer Tabelle ausgeben
// $_POST[] Eingabewerte:
// database: Datenbank, aus der die Tabelle kommt.
// table:    Tabelle, deren Datensätze dargestellt werden."
// ************************************************************************************************
// Kopfzeile einbinden
include "khsw.php";
// ************************************************************************************************
// POST-Variablen auslesen
// ************************************************************************************************
echo "Liste aller POST-Variablen<br>";
if ($_SERVER["REQUEST_METHOD"] == "POST") {
    foreach($_POST as $key => $value) {
        $value = trim($value);
        $value = stripslashes($value);
        $value = htmlspecialchars($value);
        $$key=$value;
        echo '$_POST["'.$key.'"]="'.$value.'"<br>';
    }
}
// ************************************************************************************************
// Verbindung zum Server aufbauen, Datenbank, Tabelle auswählen
// persönliche Konfigurationsdaten einbinden
include "config.inc.php";
// Datenbanknamen und Tabelle prüfen
if (empty($database) || empty($table)) die("Datenbank oder Tabelle nicht festgelegt.");
// Verbindung zum Datenbankserver definieren
$conn = new mysqli($servername, $username, $password);
// Verbindung prüfen
if ($conn->connect_error) { // Abbruch bei Fehler
  die("<p>Verbindung zum Server ".$servername." misslungen: " . $conn->connect_error."<p>\n");
}
$conn->set_charset('utf8'); // Zeichensatz utf-8 für die Verbindung zum Server einstellen
// Verbindung zur Datenbank aufbauen
$sql="USE $database";
if ($conn->query($sql) === TRUE) {
    echo "<p>Verbindung zur Datenbank $database erfolgreich.</p>\n";
} else {
    die("<p>Fehler bei der Verbindung zur Datenbank $database: " . $conn->error."</p>\n");
}
// ************************************************************************************************
// Primärschlüssel bestimmen, um jeden Datensatz eindeutig festlegen zu können
// $primary_key enthält danach ein Array mit den Attributnamen der Primärschlüssel
//$sql = "SHOW COLUMNS FROM `$table` WHERE `Key`='PRI'";
// Airbag für die Vorbereitung: falls die Primärschlüssel nicht oder falsch gesetzt wurden
$sql = "SHOW COLUMNS FROM `aaa_bibliothek`.`$table` WHERE `Key`='PRI'";
$primary_key=array();
$result = $conn->query($sql);
if ($result->num_rows > 0) {
    while ($row=$result->fetch_assoc()) {
        $primary_key[]=$row["Field"];
    }
} else {
    echo "<p>Problem: keine Primärschlüssel gesetzt.</p>\n";
}
// Schaltfläche für neuen Datensatz
echo "[Neuen Datensatz anlegen]";
// Tabelle anzeigen
    $sql = "SELECT * FROM $table";
    $result = $conn->query($sql);
    if ($result->num_rows > 0) { // Die Tabelle hat Inhalt: HTML-Tabelle vorbereiten
        echo "<p>Tabelle $table, SQL-Befehl: $sql</p>\n";
        echo "<table style='background-color: #CCCCCC; border: 1px solid black;'>";
        echo "<tr>";
        echo "<th>Aktionen</th>";
        // erste Zeile der Tabelle für die Überschriften einlesen.
        $row = $result->fetch_assoc();
        foreach ($row as $key => $value) {
	        echo "<th>$key</th>";
        }
        echo "</tr>\n";
        // alle Zeilen einzeln ausgeben
        // die erste Zeile ist bereits eingelesen, daher do ... while()
        do {
            // Primärschlüssel separat in ein array $primary_value[] einlesen
            $primary_value=array(); // leeres Array
            foreach($primary_key as $value)
                $primary_value[]=$row[$value];
            // Die WHERE-Klausel für den SELECT-Befehl zusammenbauen, die den Datensatz eindeutig bestimmt
            $i=0; $where="";
            foreach($primary_key as $value) {
                if ($i>0) $where .= " and ";
	            $where .= "$value='$primary_value[$i]'";
	            $i++;
            }
            // In der ersten Spalte stehen die Aktionen. Jede Aktion übergibt $database, $table und $where
	        echo "<tr>";
	        echo "<td style='border: 1px solid white;'>
	        <form action='edit.php' method='post'>";
	        echo "<input type='hidden' name='where' value=\"$where\">";
	        echo "<input type='hidden' name='table'    value='$table'>
	        <input type='hidden' name='database' value='$database'>
	        <input type='submit' value='Ändern'>
	        </form>
	        [Löschen]
	        </td>";
	        // Werte der einzelnen Attribute des Datensatzes ausgeben
	        foreach ($row as $key => $value) {
		        echo "<td style='border: 1px solid white;'>".$value."</td>";
	        }
	        echo "</tr>\n";
        } while($row = $result->fetch_assoc());
        echo "</table>\n";
    } else {
    echo "<p>Die Tabelle $table ist leer</p>\n";
    }
// ************************************************************************************************
// Verbindung zum Datenbankserver schließen
$conn->close(); // ********** ab hier HTML **********
echo "<form action='index.php' method='post'>\n";
echo "<input type='hidden' name='database' value='$database'>\n";
echo "<input type='submit' value='Liste der Tabellen anzeigen'>\n";
echo "</form>\n";
?> 

</body>
</html> 